#####
###  Epoz - a cross-browser-wysiwyg-editor for Zope
##   Copyright (C) 2003 Maik Jablonski (maik.jablonski@uni-bielefeld.de)
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
##   along with this program; if not, write to the Free Software
###  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#####

from ImageFile import ImageFile

misc_ = {
 
 # The Format-Controls
'epoz_script_main.js':ImageFile('skins/epoz/epoz_script_main.js.dtml', globals()),

 # Rendering of the widget
'epoz_script_widget.js':ImageFile('skins/epoz/epoz_script_widget.js.dtml', globals()),

 # Browser-detection
'epoz_script_detect.js':ImageFile('skins/epoz/epoz_script_detect.js.dtml', globals()),

 # Code for the color-selection-popup
'epoz_script_color.html':ImageFile('skins/epoz/epoz_script_color.html.dtml', globals()),

 # Code for the table-popup
'epoz_script_table.html':ImageFile('skins/epoz/epoz_script_table.html.dtml', globals()),


 # The Epoz-Language-Files
 
'epoz_lang_en.js':ImageFile('skins/epoz/epoz_lang_en.js.dtml', globals()),
'epoz_lang_de.js':ImageFile('skins/epoz/epoz_lang_de.js.dtml', globals()),
'epoz_lang_es.js':ImageFile('skins/epoz/epoz_lang_es.js.dtml', globals()),
'epoz_lang_pt_br.js':ImageFile('skins/epoz/epoz_lang_pt_br.js.dtml', globals()),

 # The Epoz-Buttons
 
'epoz_button_bgcolor.gif':ImageFile('skins/epoz/epoz_button_bgcolor.gif', globals()),
'epoz_button_bold.gif':ImageFile('skins/epoz/epoz_button_bold.gif', globals()),
'epoz_button_centre.gif':ImageFile('skins/epoz/epoz_button_centre.gif', globals()),
'epoz_button_empty.gif':ImageFile('skins/epoz/epoz_button_empty.gif', globals()),
'epoz_button_hr.gif':ImageFile('skins/epoz/epoz_button_hr.gif', globals()),
'epoz_button_hyperlink.gif':ImageFile('skins/epoz/epoz_button_hyperlink.gif', globals()),
'epoz_button_image.gif':ImageFile('skins/epoz/epoz_button_image.gif', globals()),
'epoz_button_indent.gif':ImageFile('skins/epoz/epoz_button_indent.gif', globals()),
'epoz_button_italic.gif':ImageFile('skins/epoz/epoz_button_italic.gif', globals()),
'epoz_button_left_just.gif':ImageFile('skins/epoz/epoz_button_left_just.gif', globals()),
'epoz_button_list.gif':ImageFile('skins/epoz/epoz_button_list.gif', globals()),
'epoz_button_numbered_list.gif':ImageFile('skins/epoz/epoz_button_numbered_list.gif', globals()),
'epoz_button_outdent.gif':ImageFile('skins/epoz/epoz_button_outdent.gif', globals()),
'epoz_button_redo.gif':ImageFile('skins/epoz/epoz_button_redo.gif', globals()),
'epoz_button_right_just.gif':ImageFile('skins/epoz/epoz_button_right_just.gif', globals()),
'epoz_button_table.gif':ImageFile('skins/epoz/epoz_button_table.gif', globals()),
'epoz_button_textcolor.gif':ImageFile('skins/epoz/epoz_button_textcolor.gif', globals()),
'epoz_button_tools.gif':ImageFile('skins/epoz/epoz_button_tools.gif', globals()),
'epoz_button_underline.gif':ImageFile('skins/epoz/epoz_button_underline.gif', globals()),
'epoz_button_undo.gif':ImageFile('skins/epoz/epoz_button_undo.gif', globals()),
}


def Epoz(self, name, data='', toolbox='', lang='en', 
               style='width: 600px; height: 250px;', path='/misc_/Epoz/'):
    """ Create an Epoz-Wysiwyg-Editor.
    
        name : the name of the form-element which submits the data
        data : the data to edit
        toolbox : a link to a HTML-Page which delivers additional tools
        lang: a code for the language-file (en,de,...)
        style : style-definition for the editor
        path : path to Epoz-Javascript. Needed mainly for Plone (portal_url).

        If Epoz can't create a Rich-Text-Editor, a simple textarea is created.
    """

    if data is None:
        data=''
        
    js_data = data

    # Unqoute newlines and single quotes, so the Epoz-JavaScript won't break.
    
    for (key,val) in {'\n':'\\n', '\r':'', "'":"\\'"}.items():
        js_data = js_data.replace(key, val)

    # Return the HTML-Code for the Epoz-Rich-Text-Editor
            
    return """
<iframe id="EpozIFrame" style="position: absolute; visibility: hidden; width: 0px; height: 0px;"></iframe>
<script language="JavaScript" type="text/javascript" src="%sepoz_lang_%s.js"></script>
<script language="JavaScript" type="text/javascript" src="%sepoz_script_widget.js"></script>
<script language="JavaScript" type="text/javascript" src="%sepoz_script_detect.js"></script>
<script language="JavaScript" type="text/javascript" src="%sepoz_script_main.js"></script>
<script language="JavaScript" type="text/javascript">
<!--
InitEpoz('%s','%s','%s','%s','%s');
//-->
</script>
<noscript><textarea name="%s" style="%s">%s</textarea></noscript>
""" % ( path, lang,
        path,
	    path,
	    path,
        name, js_data, toolbox, style, path,
        name, style, data
      )

# Register Epoz as global method

methods = {'Epoz': Epoz}


# And now try to register Epoz for CMF/Plone

try:
    from Products.CMFCore.DirectoryView import registerDirectory
    
    global cmfepoz_globals
    cmfepoz_globals=globals()

    def initialize(context):
        registerDirectory('skins', cmfepoz_globals)
except:
    pass
